<?php
/**
 * FuzeWorks Forms Library
 *
 * The FuzeWorks PHP FrameWork
 *
 * Copyright (C) 2013-${YEAR} i15
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 * @author    i15
 * @copyright Copyright (c) 2013 - ${YEAR}, i15. (http://i15.nl)
 * @license   https://opensource.org/licenses/MIT MIT License
 *
 * @link  https://i15.nl
 * @since Version 1.3.0
 *
 * @version Version 1.3.0
 */

namespace FuzeWorks\Forms\Fields;

class EmailField extends TextField
{

    public function validateField(): bool
    {
        parent::validateField();

        // Verify email validity
        if (!filter_var($this->value, FILTER_VALIDATE_EMAIL))
        {
            $this->valid = false;
            $this->errors[] = $this->getLabel() . " is not a valid email address.";
        }

        return $this->valid;
    }

    public function generateHtml(): string
    {
        $id = "id='".$this->getId()."'";
        $name = "name='".$this->getName()."'";
        $value = !is_null($this->value) ? "value='".$this->value."'" : "";
        $lock = $this->lock ? "disabled" : "";
        $placeholder = !is_null($this->placeholder) ? "placeholder='".$this->placeholder."'" : "";
        $maxLength = $this->maxLength > 0 ? "maxlength='".$this->maxLength."'" : "";
        $minLength = $this->minLength > 0 ? "minlength='".$this->minLength."'" : "";
        $class = "class='".implode(" ", $this->classNames)."'";

        return "<input $class type='email' $id $name $value $lock $placeholder $maxLength $minLength>";
    }
}